/*
This demo-program echoes received character
*/

#include <msp430g2231.h>

#include "ta_uart.h"

volatile char echo_byte=0,echo=0;

void Set15_25MHzClk(void)
{
  //Setting MCLK=SMCLK= ~15.25MHz
  BCSCTL1=RSEL3 | RSEL2 | RSEL1 | RSEL0;
  DCOCTL=DCO1 | DCO0;
}

void RcvHandler(unsigned char byte)
{
  if (byte=='1')
    P1OUT|=BIT6;
  
  if (byte=='0')
    P1OUT&=~BIT6;
  
  echo_byte=byte;
  
  echo=1;
}

int main(void)
{
  // Stop watchdog timer to prevent time out reset
  WDTCTL = WDTPW + WDTHOLD;
  
  Set15_25MHzClk();
  
  //Setting appropriate capacitor value for LFXT1 crystal,
  //12.5pF as suggested in documentation
  BCSCTL3=XCAP1 | XCAP0;
  
  //Setting 32768Hz crystal as a TimerA clock source,
  //continious mode (count to 0xFFFF, starting timer)
  TACTL=TASSEL0 | MC1;
  
  UART_SetRxHandler(RcvHandler);
  UART_SetRxMode();
  
  P1DIR|=BIT6;
  P1OUT&=~BIT6;
  
  __enable_interrupt();
  
  while (1)
  {
    if (echo)
    {
      UART_SetTxMode();
      UART_SendByte(echo_byte);
      UART_WaitTxCpl();
      echo=0;
      UART_SetRxMode();
    }
  }
}
